Bug 1161493 - Juniper VPN fails to start, because of missing symlink
Summary: Juniper VPN fails to start, because of missing symlink
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: icedtea-web   
(Show other bugs)
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: jiri vanek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-11-07 08:56 UTC by Thomas Meyer
Modified: 2015-06-30 01:12 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-06-30 01:12:01 UTC
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Thomas Meyer 2014-11-07 08:56:11 UTC
Hi,

the Juniper VPN fails to start, because it spawns a second java process like this:
/usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/bin/java -classpath /usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/lib/plugin.jar:/home/thomas/.juniper_networks/tncc.jar net.juniper.tnc.NARPlatform.linux.LinuxHttpNAR

This fails with a java.lang.ClassNotFoundException: netscape.javascript.JSObject because there is no plugin.jar in the directory /usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/lib/

symlinking the icedtea-web plugin.jar in this directory make the Juniper VPN work again:

$ cd /usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/lib
[thomas@localhost lib]$ ls -l plu*
lrwxrwxrwx. 1 root root 33  7. Nov 09:43 plugin.jar -> /usr/share/icedtea-web/plugin.jar

I think the plugin.jar link should be created by the icedtea-web installation script or the java installation script.

Comment 1 jiri vanek 2014-11-07 09:08:42 UTC
Hi!

Thak you for report.

Oh I think the bug is in plugin launcher:
/usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/bin/java -classpath /usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/lib/plugin.jar
It should be:
/usr/lib/jvm/java-1.7.0-openjdk-1.7.0.71-2.5.3.0.fc20.x86_64/jre/bin/java -classpath /usr/share/icedtea-web/plugin.jar

The itw is trying to be JVM independent, so it should not relay on jdk against which it is run. So there should be no linkiing from/to openjdk.

Also there should be netx.jar on classpath, but thats different question

Comment 2 jiri vanek 2014-11-07 09:15:13 UTC
hmm. How does ti behave when you select different then default jre to run itw in itweb-sttings?

Comment 3 jiri vanek 2014-11-07 10:11:54 UTC
hi!

I just realised -  it is call from ITW or form JuniperVPN? If the second - why it is relying on plugin.jar being locate in jdk?

Comment 4 Thomas Meyer 2014-11-07 18:31:44 UTC
Hi, I think the Juniper applet starts another java process with the above classpath, and it implicit relies on the plugin.jar being located in jre/lib...

Comment 5 jiri vanek 2014-11-10 10:08:04 UTC
ok. So it is completely custom  application which have completely custom  classpath   (under your control?).  Why it is not relying on /usr/share/* ? Maybe it can just try more locations?. I'm wondering it is working with plugin on classpath. but not with netx on classpath. How come? 
From above I guess, that it is application  written for oracle java which (on intel)  have always plugin in this location.  How about ibm jdk? 

Technicaly it is ok to add link to java-1.7.0-openjdk-headless -> plugin.jar

Ethically I dont like this :( Until itw is not installed this link is broken - and adding itw as depndency is no go - without hint what to do. Vice versa approach can not be done as itw should not jvm's directory.

As it is application dedicated for oracel jdk, tryin to become jvm vendor indepndent, why nto to fix the app itself?

Comment 6 Thomas Meyer 2014-11-12 09:02:46 UTC
Hi jiri,
I totally agree with you. Sadly the juniper VPN software seems to only get tested/developed against the oracle jdk/plugin.

The company I work for uses the juniper VPN software to enable a remote access to the company's network, so I've got no control of anything here.

We may should speak to somebody from juniper to get this problem addressed correctly. But I don't know whom to contact.

Comment 7 jiri vanek 2014-11-12 10:12:10 UTC
hm. So what to do with it?

If contacting provider is no go, and link from rpms is no go, then the only workaround is manual creation of the link as you suggested.

The pitfall of manual llink is that you will lost it/will make leftovers after every update (As each jdk installs to separate directory). Bu tthis is definitly something I an fix in rpm's pretrans lua script.

Comment 8 Jurijs Kolomijecs 2015-04-01 19:20:57 UTC
Did you try to disable SELinux or add a rule? It worked for me. Also had to follow this: http://kb.juniper.net/InfoCenter/index?page=content&id=KB25230
Please note it might not work with kernel 3.19.x. I don't know root cause but after NetworkConnect started all the traffic stops. So I am using kernel 3.18.9 for now.

Comment 9 Fedora End Of Life 2015-05-29 13:14:35 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 10 Fedora End Of Life 2015-06-30 01:12:01 UTC
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.